//havok_config.h
#ifndef _HAVOK_CONFIG_H
#define _HAVOK_CONFIG_H

//#define HK_CONFIG_SIMD	2

#include <Common/Base/hkBase.h>
#include <Common/Base/Container/String/hkStringBuf.h>
#include <Common/Base/Ext/hkBaseExt.h>
#include <Common/Base/Memory/System/Util/hkMemoryInitUtil.h>
#include <Common/Base/Memory/Allocator/Malloc/hkMallocAllocator.h>

#include <Physics/Dynamics/World/hkpWorld.h>
#include <Physics/Dynamics/Entity/hkpRigidBody.h>
#include <Physics/Dynamics/Entity/hkpRigidBodyCinfo.h>
#include <Physics/Utilities/Dynamics/Inertia/hkpInertiaTensorComputer.h>
#include <Physics/Collide/Shape/Convex/Box/hkpBoxShape.h>
#include <Physics/Collide/Dispatch/hkpAgentRegisterUtil.h>
#include <Physics/Collide/Filter/Group/hkpGroupFilter.h>



//Ƽ 
#define  USE_MULTITHREAD   1
#define  USE_VDB   1

#ifdef USE_MULTITHREAD
#include <Common/Base/Thread/Job/ThreadPool/Cpu/hkCpuJobThreadPool.h>
#include <Common/Base/Thread/Job/ThreadPool/Spu/hkSpuJobThreadPool.h>
#include <Common/Base/Thread/JobQueue/hkJobQueue.h>
#endif

//  
#include <Common/Visualize/hkVisualDebugger.h>
#include <Physics/Utilities/VisualDebugger/hkpPhysicsContext.h>				


//------------------------------------------------------------------------------------
//
// ʹ Ϻ õ Լ ߰Ѵ.
//
//------------------------------------------------------------------------------------

void HavokErrorReportFunction(const char* s, void* errorReportObject) ;
bool InitHavok();
void InitVisualDebuger();
bool MakeGround();
bool MakeBox();
void UpdateHavok( hkVector4& pos, hkVector4& t );
void UnInitHavok();

void InitVisualDebuger();
void UnInitVisualDebuger();

extern hkpWorld *g_world;
extern const float g_groundHalfHeight;
extern hkpRigidBody* g_groundBody;

extern const float g_bx, g_by, g_bz;
extern const int g_nx, g_ny, g_nz;
extern const int g_NUM_BODIES;
extern hkpRigidBody *g_bodies[];


enum COLLISION_LAYER
{
    LAYER_STATIC_BACKGROUND = 1,
    LAYER_ACTOR = 2,
};


#endif